/* Copyright (C) 2001  Sony Computer Entertainment Inc.
 *
 * "p2.vcl"
 *
 */
.include        "vumacros.m"     

; -------------------------------------
;
;           draw shadow particle micro 
;
; -------------------------------------
kPerspMat		.assign         0
kOffsetVecs		.assign         4
kSTVecs			.assign         8
kGifTag			.assign         12

	.macro	DoCorner  num
        lq OffsetVecs[\num], kOffsetVecs(vi00)
	mul OffsetVecs[\num], OffsetVecs[\num], vScale[x]
	add vVert, OffsetVecs[\num], vPos		
	vec_x_mat vScreen1, vVert, PerspMat
	div q, vf00[w], vScreen1[w]	
	mulq vScreen1, vScreen1, q		
	muli.w vScreen1, vScreen1, I
	ftoi4 XYZF0, vScreen1		
	sq XYZF0, 0(iXYZF_out)  
	iaddiu iXYZF_out, iXYZF_out, 2 
	sq STVecs[\num], 0(iST_out) 
	iaddiu iST_out, iST_out, 2 
	.endm

        .init_vf_all    ; allow vcl to use all VF registers
        .init_vi_all    ; allow vcl to use all VI registers
        .syntax new
 
        .vu
 
        --enter         ; declare an entry point to the code
                        ; there are no externally set registers..
        --endenter      ; end declaration of entry point

        lq PerspMat[0], kPerspMat(vi00);
        lq PerspMat[1], kPerspMat+1(vi00)
        lq PerspMat[2], kPerspMat+2(vi00)
        lq PerspMat[3], kPerspMat+3(vi00)

        lq STVecs[0], kSTVecs(vi00);
        lq STVecs[1], kSTVecs+1(vi00)
        lq STVecs[2], kSTVecs+2(vi00)
        lq STVecs[3], kSTVecs+3(vi00)

START02:
	xtop iBase
	loi -1.0
	ilwr.x iCntN, (iBase)x	; Load GIF Packet nloop Value
	iaddiu iMask, vi00, 0x7fff	;mask for NLOOP
	iand iCntN, iMask, iCntN	; mask NLOOP - this is our Count
	iadd iOffsetTmp, iCntN, iCntN    
	iadd iOffsetTmp, iOffsetTmp, iCntN  ; set offset from data area(nb x 3)
	iaddiu Pos_Col, iBase, 1   ; position & color
	iadd iKick, Pos_Col, iOffsetTmp ; xgkick
	iaddiu iRGBAQ_out, iKick, 1 ; RGBAq
	iaddiu iST_out, iKick, 2 ; ST
	iaddiu iXYZF_out, iKick, 3 ; XYZF2
	lq GifTag, 0(iBase)	; load gif tag
LOOP02:
	--LoopCS 4,4
	lqi vPos, (Pos_Col++) ; load position
	lqi.x vScale, (Pos_Col++) ; load scaling
	lqi RGBAval, (Pos_Col++) ; load RGBA

	sq RGBAval, 0(iRGBAQ_out)  ; store RGBA0
	iaddiu iRGBAQ_out, iRGBAQ_out, 9 ; 

	DoCorner 0
	DoCorner 1
	DoCorner 2
	DoCorner 3

	iaddiu iXYZF_out, iXYZF_out, 1 ;

	iaddiu iST_out, iST_out, 1 ;

	iaddi iCntN, iCntN, -1
	ibne iCntN, vi00, LOOP02
	;--------------------------------------------------------
	sq GifTag, 0(iKick);
	
	--barrier
	xgkick iKick

	--cont

	;NOP[E]	NOP
	b START02
.END









